function [y_LS_subs,t_LS_subs,y_DD_subs,t_DD_subs] = twcl_subsample(y,X,y_dd,X_dd,beta_LS,beta_DD,S_max,Nm,Tm,swtch1,swtch2,dyadic)
        
    [N,T] = size(y);
            
            
    y_LS_subs = zeros(S_max,1);
    t_LS_subs = zeros(S_max,1);
    y_DD_subs = zeros(S_max,1);
    t_DD_subs = zeros(S_max,1);
            
       
    for s = 1:S_max    
        
      
        
        UN = rand(N,1);
        UT = rand(T,1);
        
        [UN_sort,Ndw] = sort(UN);
        [UT_sort,Tdw] = sort(UT);
        Ndw = Ndw(1:Nm,1);
        Tdw = Tdw(1:Tm,1);
   
       if dyadic==1
           Tdw = Ndw;
       end
        

        y_star = y(Ndw,Tdw');
        X_star = X(Ndw,Tdw');

        
        X_dd_star = X_star - repmat(mean(X_star,2),1,Tm) - repmat(mean(X_star,1),Nm,1) + mean(mean(X_star));
        y_dd_star = y_star - repmat(mean(y_star,2),1,Tm) - repmat(mean(y_star,1),Nm,1) + mean(mean(y_star));
        
        X_dd_star = X_dd(Ndw,Tdw');
        y_dd_star = y_dd(Ndw,Tdw');
        
        [beta_LS_star,beta_DD_star,se_LS_star,se_LS_nosel_star,se_DD_star] = reg_coeffs(y_star,X_star,y_dd_star,X_dd_star,swtch1,swtch2);
        
        
        y_LS_subs(s,1) = (beta_LS_star(2,1)-beta_LS(2,1));
        t_LS_subs(s,1) = (beta_LS_star(2,1)-beta_LS(2,1))/se_LS_star(2,1);
        y_DD_subs(s,1) = (beta_DD_star(1,1)-beta_DD(1,1));
        t_DD_subs(s,1) = (beta_DD_star(1,1)-beta_DD(1,1))/se_DD_star(1,1);
        
        
        

            
    end
            
    y_LS_subs = sort(y_LS_subs);
    t_LS_subs = sort(t_LS_subs);
    y_DD_subs = sort(y_DD_subs);
    t_DD_subs = sort(t_DD_subs);
            
end