function [y_subs,t_subs] = twcl_subsample(y,sigma2_hat,S_max,Nm,Tm,swtch1,swtch2,dyadic)
        
    [N,T] = size(y);
            
   
        
    y_hat = mean(mean(y));
    
            
    y_subs = zeros(S_max,1);
    t_subs = zeros(S_max,1);
            
       
    for s = 1:S_max    
        
      
        
        UN = rand(N,1);
        UT = rand(T,1);
        
        [UN_sort,Ndw] = sort(UN);
        [UT_sort,Tdw] = sort(UT);
        Ndw = Ndw(1:Nm,1);
        Tdw = Tdw(1:Tm,1);
   
       if dyadic==1
           Tdw = Ndw;
       end
        

        y_star = y(Ndw,Tdw');
        
        alpha_star = mean(y_star,2)-y_hat;
        gamma_star = mean(y_star,1)-y_hat;
        epsilon_star = y_star - repmat(alpha_star,1,Tm)-repmat(gamma_star,Nm,1)-y_hat;
        
        
        
        sigma2_e = var(reshape(epsilon_star,Nm*Tm,1));
        sigma2_a = max(0,var(alpha_star) - sigma2_e/Tm);
        sigma2_g = max(0,var(gamma_star') - sigma2_e/Nm);        
        sigma2_star = swtch1*Tm*sigma2_a + swtch2*Nm*sigma2_g + sigma2_e;
        
        
        y_subs(s,:) = (mean(mean(y_star))-y_hat)*sqrt(Nm*Tm/sigma2_hat);
        t_subs(s,:) = (mean(mean(y_star))-y_hat)*sqrt(Nm*Tm/sigma2_star);
                
            
    end
            
y_subs = sort(y_subs);
t_subs = sort(t_subs);
            
end